#include <stdlib.h>
#include <stdio.h>
#include <string.h>

int main(int argc, char *argv[]){
  int i,j,k;
  int nface=8, ncolor=4, ncarte=nface*ncolor;
  char face[8][6]={"AS","10","ROI","DAME","VALET","9","8","7"};
  char color[4][8]={"COEUR","TREFLE","CARREAU","PIQUE"};
  char carte[32][18];
  int ord[32],flush[32];

  if(argc>=2){
    sscanf(argv[1],"%d",&k);
    srand(k);
  }

  for(i=0;i<nface;i++){
    for(j=0;j<ncolor;j++){
      strcpy(carte[i*ncolor+j],face[i]);
      strcat(carte[i*ncolor+j]," de ");
      strcat(carte[i*ncolor+j],color[j]);
    }
  }
  for(i=0;i<ncarte;i++)ord[i]=i;

  for(i=0;i<ncarte;i++){
    k=(float)rand()/(float)RAND_MAX*(ncarte-i);
    flush[i]=ord[k];
    for(j=k;j<ncarte-i-1;j++)ord[j]=ord[j+1];
/* for(j=0;j<=i;j++)printf("%d,",flush[j]);printf("\n"); */
  }

  for(i=0;i<ncarte;i++){
    printf("%s\n", carte[flush[i]]);
  }
}
