#include <netinet/in.h>
#include <stdlib.h>
#include <strings.h>
#include <stdio.h>

#define BUF_SIZE 1024
#define MY_PORT 1234

main() {

   int s, ns;
   struct sockaddr_in addr_s, addr_c;
   char buffer[ BUF_SIZE ];
   int n;
   unsigned int sz;
   int val;
   
   if( ( s = socket( AF_INET,  SOCK_STREAM, 0 ) ) < 0 ) {
      perror( "socket" );
      exit( -1 );
   }

   val = 1;
   setsockopt( s, SOL_SOCKET, SO_REUSEADDR, &val, sizeof( val ) );

   bzero( &addr_s, sizeof( addr_s ) );
   addr_s.sin_family = AF_INET;
   addr_s.sin_port   = htons( MY_PORT );

   if( bind( s, (struct sockaddr *)&addr_s, sizeof( addr_s ) ) != 0 ) {
      perror( "bind" );
      exit( -2 );
   }

   if( listen( s, 5 ) != 0 ) {
      perror( "listen" );
      exit( -3 );
   }

   sz = sizeof( addr_c );
   if( ( ns = accept( s, (struct sockaddr *)&addr_c, &sz ) ) < 0 ) {
      perror( "accept" );
      exit( -4 );
   }

   printf( "Connexion from: %s, port: %d\n",
           inet_ntoa( addr_c.sin_addr ),
           ntohs( addr_c.sin_port ) );

   bzero( buffer, BUF_SIZE );
   if( ( n = read( ns, buffer, BUF_SIZE ) ) < 0 ) {
      perror( "read" );
      exit( -5 );
   }

   printf( "%d bytes read:\n%s", n, buffer );

   close( ns );
   close( s );

}
