#include <netinet/in.h>
#include <stdlib.h>
#include <strings.h>
#include <stdio.h>

#define BUF_SIZE 1024
#define MY_PORT 1234

main() {

   int s;
   struct sockaddr_in addr_s, addr_c;
   char buffer[ BUF_SIZE ];
   int n;
   unsigned int sz;
   
   if( ( s = socket( AF_INET,  SOCK_DGRAM, 0 ) ) < 0 ) {
      perror( "socket" );
      exit( -1 );
   }

   bzero( &addr_s, sizeof( addr_s ) );
   addr_s.sin_family = AF_INET;
   addr_s.sin_port   = htons( MY_PORT );

   if( bind( s, (struct sockaddr *)&addr_s, sizeof( addr_s ) ) != 0 ) {
      perror( "bind" );
      exit( -2 );
   }
while(1) {
   bzero( buffer, BUF_SIZE );
   sz = sizeof( addr_c );
   if( ( n = recvfrom( s, buffer, BUF_SIZE, 0, 
              (struct sockaddr *)&addr_c, &sz ) ) < 0 ) {
      perror( "recvfrom" );
      exit( -5 );
   }

   printf( "Connexion from: %s, port: %d\n",
           inet_ntoa( addr_c.sin_addr ),
           ntohs( addr_c.sin_port ) );

   printf( "%d bytes read:\n%s", n, buffer );
}

   close( s );
   exit(0);

}
