/* 
	Envoi d'un mail depuis un programme C
*/

#include <stdio.h>
#include <sys/wait.h>

int pid;
void waitproc();

main()
{	
		  
    int pip_in[2];
    char *argv[5];
    FILE *fdout;
    
    pipe(pip_in);
	if((pid=fork()) == 0 ){
		printf("In the child, pid = %d\n", pid);
		close(0);
		dup(pip_in[0]);
		close(pip_in[0]);
		close(pip_in[1]);
		argv[0]="mail";
		argv[1]="-s";
		argv[2]="Test";
		argv[3]="n.giraud@ipnl.in2p3.fr"; 
		argv[4]=NULL;
		execve("/usr/bin/mail", argv, NULL);
	}else{
		printf("In the parent, pid = %d\n", pid);
		close(pip_in[0]);
		fdout=fdopen(pip_in[1],"w");
		fprintf(fdout, "C'est juste un petit essai,\n");
		fprintf(fdout, "mais on pourrait faire des choses bien plus compliquees\n");
		fclose(fdout);
		waitproc();
	}
		
}

void waitproc()
{
        int pid;
        int statusp;

        pid=wait(&statusp);
        if(pid == -1){
                printf("No process\n");
                return;
        }else if(WIFSTOPPED(statusp)){
                printf("Process %d stopped by signal %d\n", pid, WSTOPSIG(statusp));
                return;
        }else if(WIFSIGNALED(statusp)){
                printf("Process %d killed by signal %d %s\n",
                        pid, WTERMSIG(statusp), WCOREDUMP(statusp)?", core dumped":"");
                return;
        }else{
                printf("Process %d terminated, rc = %d\n", pid, WEXITSTATUS(statusp));
                return;
        }
}


