/*
	Print i-node content of arg
*/

#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>

struct stat *buf_stat;

main(int argc, char *argv[])

{
	
	if(argc != 2)exit(-1);
	
	buf_stat = (struct stat *) malloc(sizeof(struct stat));
	
	if(stat(argv[1], buf_stat) != 0)exit(-2);
	printf("st_dev        : (%i, %i)\n", buf_stat->st_dev/256, buf_stat->st_dev%256);
	printf("st_ino        : %i\n", buf_stat->st_ino);
	printf("st_mode       : %07o\n", buf_stat->st_mode);
	printf("st_nlink      : %i\n", buf_stat->st_nlink);
	printf("st_uid        : %i\n", buf_stat->st_uid);
	printf("st_gid        : %i\n", buf_stat->st_gid);
	if(buf_stat->st_mode & S_IFCHR){
		printf("st_rdev       : (%i, %i)\n", buf_stat->st_rdev/256, buf_stat->st_rdev%256);
	}
	printf("st_size       : %i\n", buf_stat->st_size);
	printf("st_atime      : %s", ctime(&buf_stat->st_atime));
	printf("st_mtime      : %s", ctime(&buf_stat->st_mtime));
	printf("st_ctime      : %s", ctime(&buf_stat->st_ctime));
	
}
	
