/*
  Probleme des anniversaires
*/

#include <stdio.h>
#include <stdlib.h>

#define NDAY 365
#define NTRY 100000
#define FROMTO 2
#define UPTO 70
main(){

  int a[NDAY+1];
  int m,n,i,j;
  int hit;
  float p, tothit;
  float pt;

  for(m=FROMTO;m<=UPTO;m++){
    p=0;
    tothit=0.;
    for(n=0;n<NTRY;n++){
      for(i=0;i<m;i++) a[i]=(int)(((float)rand()*(float)NDAY)/(float)RAND_MAX);
      hit=0;
      for(i=0;i<m-1;i++){
        for(j=i+1;j<m;j++){
          if(a[i]==a[j])hit++;
        }
      }
      tothit+=hit;
      if(hit>0)p++;
    }
    pt=1.;
    for(i=0;i<m;i++)pt=pt*(float)(NDAY-i)/(float)NDAY;
    pt=1.-pt;
    p=p/NTRY;
/*
 m      : nombre de personnes
 P      : probabilite statistique de 2 anniversaires communs
 pt     : probabilite theorique
 hitbar : nombre moyen d'anniversaires communs
*/
    printf("m=%d, p=%f, pt=%f, hitbar=%f\n",m, p, pt, tothit/NTRY);
  }
}
