#include <stdlib.h>
#include "stack.h"

#include <string.h>

#define MAX_DIGIT 16

float stk[STK_SIZE];
int sp = 0;

main(){
  float a,b;
  char s[MAX_DIGIT];

  while(1) {
    printf(": ");
    fgets(s, MAX_DIGIT, stdin);
    if( isdigit(*s) || strlen(s) > 2 ){
      if(sscanf(s,"%f",&a)!=1) {
        printf("invalid number: %s", s);
        continue;
      }
      push( a );
      continue;
    }
    switch (*s) {
      case '+':
        a = pop();
        b = pop();
        printf("%f\n", b + a );
        push( b + a );
        break;
      case '-':
        a = pop();
        b = pop();
        printf("%f\n", b - a );
        push( b - a );
        break;
      case '*':
        a = pop();
        b = pop();
        printf("%f\n", b * a );
        push( b * a );
        break;
      case '/':
        a = pop();
        b = pop();
        printf("%f\n", b / a );
        push( b / a );
        break;
      case '.':
        a = pop();
        printf("%f\n", a );
        break;
      case 'd':
        dump();
        break;
      case 'q':
        exit(0);
      default:
        printf("invalid command: %s", s);
        break;
     }
  }
}
