#include <netinet/in.h>
#include <stdio.h>
#include <strings.h>
#include <stdlib.h>

#define BUF_SIZE 1024
#define MY_PORT 1234

main( int argc, char *argv[] ) {

   int s;
   struct sockaddr_in addr_s;
   char buffer[ BUF_SIZE ];

   if( argc != 2 ) {
      printf( "usage: %s hostname\n", argv[0] );
      exit( -1 );
   }
   
   if( ( s = socket( AF_INET,  SOCK_DGRAM, 0 ) ) < 0 ) {
      perror( "socket" );
      exit( -1 );
   }

   bzero( &addr_s, sizeof( addr_s ) );
   addr_s.sin_family = AF_INET;
   addr_s.sin_port   = htons( MY_PORT );
   if( ( addr_s.sin_addr.s_addr = inet_addr( argv[1] ) ) == -1 ) {
      perror( "inet_addr" );
      exit( -2 );
   }

   if( gets( buffer ) == 0 ) {
      perror( "gets" );
      exit( -4 );
   }

   strcat( buffer, "\n" );
   if( sendto( s, buffer, strlen( buffer ), 0, 
               (struct sockaddr *)&addr_s, sizeof( addr_s ) ) <0 ) {
      perror( "sendto" );
      exit( -5 );
   }

   close( s );
   exit(0);

}
