#include <stdlib.h>
#include <setjmp.h>
#include <stdio.h>
#include <unistd.h>

void get_hup(int);

jmp_buf context;
FILE * log_file;

int main(){
  int fd, fdmax;
  pid_t pid;
  if( (pid = fork() ) <0 ) exit(-1);
  else if (pid!=0) exit(0);
  setsid();
  fdmax=getdtablesize();
  for(fd=0;fd<fdmax;fd++)close(fd);
  chdir("daemon_dir");
  umask(0);
  signal(SIGHUP, get_hup);
  signal(SIGUSR1, get_hup);
  log_file = fopen( "log", "w");
  fprintf(log_file,"setjmp: %d\n", setjmp(context));
  fflush(log_file);
  sleep(1000);
}

void get_hup(int s){
  signal(SIGHUP, SIG_IGN);
  fprintf(log_file,"in get_hup with signal: %d\n",s);
  signal(SIGHUP, get_hup);
  longjmp(context,1);
}
