/*
	Exemple de execve avec des variables d'environnement 
*/

#include <stdio.h>
#include <sys/wait.h>

int pid;
void waitproc();

main()
{	
		  
    int pip_out[2];
    char *argv[2];
    char *envp[2];
    char resp;
    
    pipe(pip_out);
	if((pid=fork()) == 0 ){
		printf("In the child, pid = %d\n", pid);
		close(1);
		dup(pip_out[1]);
		close(pip_out[0]);
		close(pip_out[1]);
		argv[0]="test";
		argv[1]=NULL;
		envp[0]="TEST=coucou";
		envp[1]=NULL;
		execve("./test", argv, envp);
	}else{
		printf("In the parent, pid = %d\n", pid);
		close(pip_out[1]);
  	  	while(read(pip_out[0], &resp, 1) >0)write(1,&resp,1);
		waitproc();
	}
		
}

void waitproc()
{
        int pid;
        int statusp;

        pid=wait(&statusp);
        if(pid == -1){
                printf("No process\n");
                return;
        }else if(WIFSTOPPED(statusp)){
                printf("Process %d stopped by signal %d\n", pid, WSTOPSIG(statusp));
                return;
        }else if(WIFSIGNALED(statusp)){
                printf("Process %d killed by signal %d %s\n",
                        pid, WTERMSIG(statusp), WCOREDUMP(statusp)?", core dumped":"");
                return;
        }else{
                printf("Process %d terminated, rc = %d\n", pid, WEXITSTATUS(statusp));
                return;
        }
}


