#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>

main(int argc, char *argv[]) {

  DIR * dir;
  struct dirent * d;

  if( argc != 2 ) {
    printf("usage: rd dir\n");
    exit(-2);
  }

  if( ( dir = opendir( argv[1] ) ) == NULL ) {
    printf("unable to open %s\n", argv[1]);
    exit(-1);
  }

  while( ( d = readdir( dir ) ) != NULL ) {
    if( !strcmp( ".", d->d_name) || !strcmp( "..", d->d_name) ) continue;
    printf("entry: %s\n", d->d_name );
  }

  closedir( dir);
}
