#include <sys/types.h>
#include <sys/shm.h>
#include <sys/ipc.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

#define MAX_MACH	25
#define SHM_FILE "m"

struct machine{
	char 	flag;
#define LOCKED 0x01
	char 	name[10];
	int 	in_pkt;
	int	out_pkt;

};

struct machine_v{
	struct machine machine[MAX_MACH];
} *shm_mach;

main()
{

	int shm_id;
	key_t	shm_key;
	
	if((shm_key = ftok(SHM_FILE, '\x01')) <0){
		perror("ftok");
		exit(-1);
	}

	printf("key: %x\n", shm_key);

	if((shm_id = shmget( shm_key, 0, IPC_CREAT)) <0){
		perror("shmget");
		exit(-1);
	}

	printf("shmget: %d\n", shm_id);

	if((shm_mach =  (struct machine_v *)shmat(shm_id, 0, 0)) <0){
		perror("shmat");
		exit(-1);
	}

	printf("shm_mach: %x\n", shm_mach);

	for(;;){
		int i;
		for(i=0; i<MAX_MACH; i++){
/*
			while((shm_mach->machine[i]).flag & LOCKED){
				printf("%d locked\n", i);
				sleep(1);
			}
*/
			printf("%s: %d, %d\n", (shm_mach->machine[i]).name,  (shm_mach->machine[i]).in_pkt,  (shm_mach->machine[i]).out_pkt);
		}
/*
		sleep(1);
*/
	}
}
