#include <stdio.h>

struct entry {
  char name[40];
  char phone[40];
  struct entry *next;
};

struct entry *sl_insert( struct entry *, struct entry * );
struct entry *sl_delete( char *, struct entry * );
void display( struct entry * );

int main(){
  struct entry *first=NULL;
  struct entry e1 = { "Cecile", "48418", NULL };
  struct entry e2 = { "Guillaume", "48146", NULL };
  struct entry e3 = { "Bruno", "31122", NULL }; 
  struct entry e4 = { "Clement", "31889", NULL }; 
  struct entry e5 = { "Christophe", "48146", NULL }; 

  first = sl_insert( &e1, first);
  display(first);
  first = sl_insert( &e2, first);
  display(first);
  first = sl_insert( &e3, first);
  display(first);
  first = sl_insert( &e4, first);
  display(first);
  first = sl_insert( &e5, first);
  display(first);
  first = sl_delete( "Clement", first );
  display(first);
  first = sl_delete( "Toto", first );
  display(first);
  first = sl_delete( "Bruno", first );
  display(first);
  first = sl_delete( "Guillaume", first );
  display(first);
  first = sl_delete( "Christophe", first );
  display(first);
  first = sl_delete( "Cecile", first );
  display(first);
}

struct entry *sl_insert( struct entry *i, struct entry *first ){
  struct entry *old, *current;
  if(!first){
    i->next = NULL;
printf("init entry\n");
    return i;
  }
  old=NULL;
  current=first;
  while(current){
    if(strcmp(current->name,i->name) <0 ){
      old=current;
      current = current->next;
    } else {
      if(!old){
        i->next=first;
printf("first entry\n");
        return i;
      } else {
        old->next=i;
        i->next=current;
printf("middle entry\n");
        return first;
      }
    }
  }
  old->next=i;
  i->next=NULL;
printf("last entry\n");
  return first;
}

struct entry *sl_delete( char *name, struct entry *first ){
  struct entry *old, *current;
  old=NULL;
  current=first;
  while(current){
    if(strcmp(current->name,name) !=0 ){
      old=current;
      current = current->next;
    } else {
      if(!old){
printf("first entry\n");
        return current->next;
      } else {
        old->next=current->next;
printf("middle entry\n");
        return first;
      }
    }
  }
  printf("not found\n");
printf("last entry\n");
  return first;
}

void display( struct entry *first ){
  while(first){
    printf("%s\n", first->name);
    first=first->next;
  }
}
